'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _utils = require('./utils');

/**
 * Port of redux [`combineReducers`](http://rackt.org/redux/docs/api/combineReducers.html). The difference is though
 * that it's allowed to provide reducers as generators. Please, be aware that the function does not contain any
 * special sanity checks. The reason why is that this is quite specific implementation which should most likely
 * be in user land.
 *
 * @param {Map} Map of reducers, key will be used as key in the application state
 * @returns {Function} Single reducer
 */

exports['default'] = function (reducers) {
  var initialState = (0, _utils.mapObject)(reducers, function () {
    return undefined;
  });

  return _regeneratorRuntime.mark(function callee$1$0(state, action) {
    if (state === undefined) state = initialState;
    var hasChanged, mutatedReduction;
    return _regeneratorRuntime.wrap(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          hasChanged = undefined;
          return context$2$0.delegateYield((0, _utils.generatorMapObject)(reducers, _regeneratorRuntime.mark(function callee$2$0(reducer, key) {
            var previousKeyedReduction, nextKeyedReduction;
            return _regeneratorRuntime.wrap(function callee$2$0$(context$3$0) {
              while (1) switch (context$3$0.prev = context$3$0.next) {
                case 0:
                  previousKeyedReduction = state[key];
                  nextKeyedReduction = undefined;

                  if (!(0, _utils.isGenerator)(reducer)) {
                    context$3$0.next = 7;
                    break;
                  }

                  return context$3$0.delegateYield(reducer(previousKeyedReduction, action), 't0', 4);

                case 4:
                  nextKeyedReduction = context$3$0.t0;
                  context$3$0.next = 8;
                  break;

                case 7:
                  nextKeyedReduction = reducer(previousKeyedReduction, action);

                case 8:

                  hasChanged = hasChanged || nextKeyedReduction !== previousKeyedReduction;
                  return context$3$0.abrupt('return', nextKeyedReduction);

                case 10:
                case 'end':
                  return context$3$0.stop();
              }
            }, callee$2$0, this);
          })), 't0', 2);

        case 2:
          mutatedReduction = context$2$0.t0;
          return context$2$0.abrupt('return', hasChanged ? mutatedReduction : state);

        case 4:
        case 'end':
          return context$2$0.stop();
      }
    }, callee$1$0, this);
  });
};

module.exports = exports['default'];